/*
 *  Copyright (c) 2020-current NetApp
 *  All rights reserved
 */

// Code generated by informer-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	time "time"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
	volumecontrollerv1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
	versioned "quark.netapp.io/volume-controller/pkg/client/clientset/versioned"
	internalinterfaces "quark.netapp.io/volume-controller/pkg/client/informers/externalversions/internalinterfaces"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/client/listers/volumecontroller/v1alpha1"
)

// NetAppSnapshotPolicyInformer provides access to a shared informer and lister for
// NetAppSnapshotPolicies.
type NetAppSnapshotPolicyInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1alpha1.NetAppSnapshotPolicyLister
}

type netAppSnapshotPolicyInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewNetAppSnapshotPolicyInformer constructs a new informer for NetAppSnapshotPolicy type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewNetAppSnapshotPolicyInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredNetAppSnapshotPolicyInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredNetAppSnapshotPolicyInformer constructs a new informer for NetAppSnapshotPolicy type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredNetAppSnapshotPolicyInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.QuarkV1alpha1().NetAppSnapshotPolicies(namespace).List(context.TODO(), options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.QuarkV1alpha1().NetAppSnapshotPolicies(namespace).Watch(context.TODO(), options)
			},
		},
		&volumecontrollerv1alpha1.NetAppSnapshotPolicy{},
		resyncPeriod,
		indexers,
	)
}

func (f *netAppSnapshotPolicyInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredNetAppSnapshotPolicyInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *netAppSnapshotPolicyInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&volumecontrollerv1alpha1.NetAppSnapshotPolicy{}, f.defaultInformer)
}

func (f *netAppSnapshotPolicyInformer) Lister() v1alpha1.NetAppSnapshotPolicyLister {
	return v1alpha1.NewNetAppSnapshotPolicyLister(f.Informer().GetIndexer())
}
