/*
 *  Copyright (c) 2020-current NetApp
 *  All rights reserved
 */

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
)

// NetAppExportPolicyLister helps list NetAppExportPolicies.
// All objects returned here must be treated as read-only.
type NetAppExportPolicyLister interface {
	// List lists all NetAppExportPolicies in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppExportPolicy, err error)
	// NetAppExportPolicies returns an object that can list and get NetAppExportPolicies.
	NetAppExportPolicies(namespace string) NetAppExportPolicyNamespaceLister
	NetAppExportPolicyListerExpansion
}

// netAppExportPolicyLister implements the NetAppExportPolicyLister interface.
type netAppExportPolicyLister struct {
	indexer cache.Indexer
}

// NewNetAppExportPolicyLister returns a new NetAppExportPolicyLister.
func NewNetAppExportPolicyLister(indexer cache.Indexer) NetAppExportPolicyLister {
	return &netAppExportPolicyLister{indexer: indexer}
}

// List lists all NetAppExportPolicies in the indexer.
func (s *netAppExportPolicyLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppExportPolicy, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppExportPolicy))
	})
	return ret, err
}

// NetAppExportPolicies returns an object that can list and get NetAppExportPolicies.
func (s *netAppExportPolicyLister) NetAppExportPolicies(namespace string) NetAppExportPolicyNamespaceLister {
	return netAppExportPolicyNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// NetAppExportPolicyNamespaceLister helps list and get NetAppExportPolicies.
// All objects returned here must be treated as read-only.
type NetAppExportPolicyNamespaceLister interface {
	// List lists all NetAppExportPolicies in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppExportPolicy, err error)
	// Get retrieves the NetAppExportPolicy from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.NetAppExportPolicy, error)
	NetAppExportPolicyNamespaceListerExpansion
}

// netAppExportPolicyNamespaceLister implements the NetAppExportPolicyNamespaceLister
// interface.
type netAppExportPolicyNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all NetAppExportPolicies in the indexer for a given namespace.
func (s netAppExportPolicyNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppExportPolicy, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppExportPolicy))
	})
	return ret, err
}

// Get retrieves the NetAppExportPolicy from the indexer for a given namespace and name.
func (s netAppExportPolicyNamespaceLister) Get(name string) (*v1alpha1.NetAppExportPolicy, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("netappexportpolicy"), name)
	}
	return obj.(*v1alpha1.NetAppExportPolicy), nil
}
