/*
 *  Copyright (c) 2020-current NetApp
 *  All rights reserved
 */

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
)

// NetAppVolumeCloudSnapshotLister helps list NetAppVolumeCloudSnapshots.
// All objects returned here must be treated as read-only.
type NetAppVolumeCloudSnapshotLister interface {
	// List lists all NetAppVolumeCloudSnapshots in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppVolumeCloudSnapshot, err error)
	// NetAppVolumeCloudSnapshots returns an object that can list and get NetAppVolumeCloudSnapshots.
	NetAppVolumeCloudSnapshots(namespace string) NetAppVolumeCloudSnapshotNamespaceLister
	NetAppVolumeCloudSnapshotListerExpansion
}

// netAppVolumeCloudSnapshotLister implements the NetAppVolumeCloudSnapshotLister interface.
type netAppVolumeCloudSnapshotLister struct {
	indexer cache.Indexer
}

// NewNetAppVolumeCloudSnapshotLister returns a new NetAppVolumeCloudSnapshotLister.
func NewNetAppVolumeCloudSnapshotLister(indexer cache.Indexer) NetAppVolumeCloudSnapshotLister {
	return &netAppVolumeCloudSnapshotLister{indexer: indexer}
}

// List lists all NetAppVolumeCloudSnapshots in the indexer.
func (s *netAppVolumeCloudSnapshotLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppVolumeCloudSnapshot, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppVolumeCloudSnapshot))
	})
	return ret, err
}

// NetAppVolumeCloudSnapshots returns an object that can list and get NetAppVolumeCloudSnapshots.
func (s *netAppVolumeCloudSnapshotLister) NetAppVolumeCloudSnapshots(namespace string) NetAppVolumeCloudSnapshotNamespaceLister {
	return netAppVolumeCloudSnapshotNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// NetAppVolumeCloudSnapshotNamespaceLister helps list and get NetAppVolumeCloudSnapshots.
// All objects returned here must be treated as read-only.
type NetAppVolumeCloudSnapshotNamespaceLister interface {
	// List lists all NetAppVolumeCloudSnapshots in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppVolumeCloudSnapshot, err error)
	// Get retrieves the NetAppVolumeCloudSnapshot from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.NetAppVolumeCloudSnapshot, error)
	NetAppVolumeCloudSnapshotNamespaceListerExpansion
}

// netAppVolumeCloudSnapshotNamespaceLister implements the NetAppVolumeCloudSnapshotNamespaceLister
// interface.
type netAppVolumeCloudSnapshotNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all NetAppVolumeCloudSnapshots in the indexer for a given namespace.
func (s netAppVolumeCloudSnapshotNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppVolumeCloudSnapshot, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppVolumeCloudSnapshot))
	})
	return ret, err
}

// Get retrieves the NetAppVolumeCloudSnapshot from the indexer for a given namespace and name.
func (s netAppVolumeCloudSnapshotNamespaceLister) Get(name string) (*v1alpha1.NetAppVolumeCloudSnapshot, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("netappvolumecloudsnapshot"), name)
	}
	return obj.(*v1alpha1.NetAppVolumeCloudSnapshot), nil
}
