/*
 *  Copyright (c) 2020-current NetApp
 *  All rights reserved
 */

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
)

// NetAppVolumeReplicationLister helps list NetAppVolumeReplications.
// All objects returned here must be treated as read-only.
type NetAppVolumeReplicationLister interface {
	// List lists all NetAppVolumeReplications in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppVolumeReplication, err error)
	// NetAppVolumeReplications returns an object that can list and get NetAppVolumeReplications.
	NetAppVolumeReplications(namespace string) NetAppVolumeReplicationNamespaceLister
	NetAppVolumeReplicationListerExpansion
}

// netAppVolumeReplicationLister implements the NetAppVolumeReplicationLister interface.
type netAppVolumeReplicationLister struct {
	indexer cache.Indexer
}

// NewNetAppVolumeReplicationLister returns a new NetAppVolumeReplicationLister.
func NewNetAppVolumeReplicationLister(indexer cache.Indexer) NetAppVolumeReplicationLister {
	return &netAppVolumeReplicationLister{indexer: indexer}
}

// List lists all NetAppVolumeReplications in the indexer.
func (s *netAppVolumeReplicationLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppVolumeReplication, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppVolumeReplication))
	})
	return ret, err
}

// NetAppVolumeReplications returns an object that can list and get NetAppVolumeReplications.
func (s *netAppVolumeReplicationLister) NetAppVolumeReplications(namespace string) NetAppVolumeReplicationNamespaceLister {
	return netAppVolumeReplicationNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// NetAppVolumeReplicationNamespaceLister helps list and get NetAppVolumeReplications.
// All objects returned here must be treated as read-only.
type NetAppVolumeReplicationNamespaceLister interface {
	// List lists all NetAppVolumeReplications in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppVolumeReplication, err error)
	// Get retrieves the NetAppVolumeReplication from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.NetAppVolumeReplication, error)
	NetAppVolumeReplicationNamespaceListerExpansion
}

// netAppVolumeReplicationNamespaceLister implements the NetAppVolumeReplicationNamespaceLister
// interface.
type netAppVolumeReplicationNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all NetAppVolumeReplications in the indexer for a given namespace.
func (s netAppVolumeReplicationNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppVolumeReplication, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppVolumeReplication))
	})
	return ret, err
}

// Get retrieves the NetAppVolumeReplication from the indexer for a given namespace and name.
func (s netAppVolumeReplicationNamespaceLister) Get(name string) (*v1alpha1.NetAppVolumeReplication, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("netappvolumereplication"), name)
	}
	return obj.(*v1alpha1.NetAppVolumeReplication), nil
}
