/*
 *  Copyright (c) 2020-current NetApp
 *  All rights reserved
 */

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
)

// NetAppVolumeSnapshotsListLister helps list NetAppVolumeSnapshotsLists.
// All objects returned here must be treated as read-only.
type NetAppVolumeSnapshotsListLister interface {
	// List lists all NetAppVolumeSnapshotsLists in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppVolumeSnapshotsList, err error)
	// NetAppVolumeSnapshotsLists returns an object that can list and get NetAppVolumeSnapshotsLists.
	NetAppVolumeSnapshotsLists(namespace string) NetAppVolumeSnapshotsListNamespaceLister
	NetAppVolumeSnapshotsListListerExpansion
}

// netAppVolumeSnapshotsListLister implements the NetAppVolumeSnapshotsListLister interface.
type netAppVolumeSnapshotsListLister struct {
	indexer cache.Indexer
}

// NewNetAppVolumeSnapshotsListLister returns a new NetAppVolumeSnapshotsListLister.
func NewNetAppVolumeSnapshotsListLister(indexer cache.Indexer) NetAppVolumeSnapshotsListLister {
	return &netAppVolumeSnapshotsListLister{indexer: indexer}
}

// List lists all NetAppVolumeSnapshotsLists in the indexer.
func (s *netAppVolumeSnapshotsListLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppVolumeSnapshotsList, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppVolumeSnapshotsList))
	})
	return ret, err
}

// NetAppVolumeSnapshotsLists returns an object that can list and get NetAppVolumeSnapshotsLists.
func (s *netAppVolumeSnapshotsListLister) NetAppVolumeSnapshotsLists(namespace string) NetAppVolumeSnapshotsListNamespaceLister {
	return netAppVolumeSnapshotsListNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// NetAppVolumeSnapshotsListNamespaceLister helps list and get NetAppVolumeSnapshotsLists.
// All objects returned here must be treated as read-only.
type NetAppVolumeSnapshotsListNamespaceLister interface {
	// List lists all NetAppVolumeSnapshotsLists in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppVolumeSnapshotsList, err error)
	// Get retrieves the NetAppVolumeSnapshotsList from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.NetAppVolumeSnapshotsList, error)
	NetAppVolumeSnapshotsListNamespaceListerExpansion
}

// netAppVolumeSnapshotsListNamespaceLister implements the NetAppVolumeSnapshotsListNamespaceLister
// interface.
type netAppVolumeSnapshotsListNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all NetAppVolumeSnapshotsLists in the indexer for a given namespace.
func (s netAppVolumeSnapshotsListNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppVolumeSnapshotsList, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppVolumeSnapshotsList))
	})
	return ret, err
}

// Get retrieves the NetAppVolumeSnapshotsList from the indexer for a given namespace and name.
func (s netAppVolumeSnapshotsListNamespaceLister) Get(name string) (*v1alpha1.NetAppVolumeSnapshotsList, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("netappvolumesnapshotslist"), name)
	}
	return obj.(*v1alpha1.NetAppVolumeSnapshotsList), nil
}
